---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 15.07.2021 17:54
---
local _, BohemkaDKP = ...

function BohemkaDKP:ShareProfessions()
    local skills = {}
    local skillRanks = {}
    for skillIndex = 1, GetNumSkillLines() do
        local skillName, isHeader, _, skillRank, _, _,
        _, _, _, _, _, _,
        _ = GetSkillLineInfo(skillIndex)
        if not isHeader then
            if BohemkaDKP.PROFESSIONS[skillName] then
                skillRanks[skillName] = skillRank
            end
        end
    end
    local _, _, offset, numSlots = GetSpellTabInfo(1)
    for j = offset+1, offset+numSlots do
        local name, _, _, _, _, _, spellId = GetSpellInfo(GetSpellBookItemName(j, BOOKTYPE_SPELL))
        if BohemkaDKP.PROFESSIONS[name] then
            local data = spellId
            if name == "Find Herbs" then
                data = 9134
                name = "Herbalism"
            end
            if skillRanks[name] then
                data = data.."-"..skillRanks[name]
            end
            table.insert(skills, data)
        end
    end
    local payload = table.concat(skills, ",")
    self:SendEvent("GUILD", self.EVENT.PROFESSION_INFO, payload)
end

function BohemkaDKP:OnProfessionInfo(payload, sender)
    local spellIds = { strsplit(",", payload) }
    if sender then
        local tmp = {}
        for _, v in ipairs(spellIds) do
            local spellId, spellRank = strsplit("-", v)
            spellId = tonumber(spellId)
            local name, _, icon = GetSpellInfo(spellId)
            local order = BohemkaDKP.PROFESSIONS[name]
            table.insert(tmp, {name = name, order = order, id = spellId, icon = icon, rank = spellRank})
        end
        table.sort(tmp, function (a, b) return a.order < b.order end)
        RosterData.professions[sender] = tmp
    end
end

function BohemkaDKP:GetPlayerProfessions(fullName)
    return RosterData.professions[fullName] or {}
end
function BohemkaDKP:RequestProfessionInfo()
    self:SendEvent("GUILD", self.EVENT.PROFESSION_INFO_REQUEST)
end

function BohemkaDKP:OnProfessionInfoRequest(sender)
    if sender == self:GetPlayerName(true) then
        return
    end
    self:ShareProfessions()
end
