---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 15.07.2021 17:53
---
local _, BohemkaDKP = ...

function BohemkaDKP:ShareTalents()
    local numTabs = GetNumTalentTabs();
    local tabs = {}
    for t=1, numTabs do
        local name, _, pointsSpent = GetTalentTabInfo(t)
        table.insert(tabs, name:gsub("%s+", "").."-"..pointsSpent)
    end
    local payload = table.concat(tabs, ",")
    self:SendEvent("GUILD", self.EVENT.TALENTS_INFO, payload)
end

function BohemkaDKP:OnTalentsInfo(payload, sender)
    local talents = { strsplit(",", payload) }
    if self.guildRoster[sender] then
        local class = select(11, unpack(self.guildRoster[sender]))
        local tmp = {}
        local amounts = {}
        local spec
        for _, v in ipairs(talents) do
            local name, numTalents = strsplit("-", v)
            local icon = self.TALENTS[class][name]
            local amount = tonumber(numTalents)
            local data = {name = name, icon = icon, amount = amount}
            table.insert(tmp, data)
            table.insert(amounts, amount)
            if not spec or spec.amount < amount then
                spec = data
            end
        end
        RosterData.talents[sender] = {tmp, spec, amounts}
    end
end

function BohemkaDKP:GetPlayerTalents(fullName)
    if RosterData.talents[fullName] then
        return unpack(RosterData.talents[fullName])
    end
end

function BohemkaDKP:RequestTalentsInfo()
    self:SendEvent("GUILD", self.EVENT.TALENTS_INFO_REQUEST)
end

function BohemkaDKP:OnTalentsInfoRequest(sender)
    if sender == self:GetPlayerName(true) then
        return
    end
    self:ShareTalents()
end
